unit Unit14;

interface

uses
  Windows, SysUtils, Variants, Classes, Controls, Forms,
  Dialogs, Buttons, Inifiles, ComCtrls, StdCtrls;

type
  TForm14 = class(TForm)
    Label14: TLabel;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Edit1: TEdit;
    BitBtn1: TButton;
    BitBtn2: TButton;
    Button1: TButton;
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form14: TForm14;

implementation

uses Unit1;

{$R *.dfm}

procedure TForm14.FormShow(Sender: TObject);
var MyIniFile:Tinifile;
    j:integer;
begin
form14.Left:=round(screen.Width/2-form14.Width/2);
form14.Top:=round(screen.Height/2-form14.Height/2);
Button1.Enabled:=false;
Combobox1.ItemIndex:=-1;
edit1.Text:='';
Combobox1.Items.Clear;
//  combobox1
MyIniFile := TIniFile.Create(ExtractFilePath(Application.EXEName)+'material.lst');
j:=1;
with MyIniFile do
begin
while readstring('Material', inttostr(j), '')<>'' do begin
Combobox1.Items.Addobject(readstring('Material', inttostr(j), ''),TObject(vsList));
j:=j+1;
end;
end;
MyIniFile.Free;
combobox1.ItemIndex:=0;
combobox1change(sender);
end;

procedure TForm14.ComboBox1Change(Sender: TObject);
var MyIniFile:Tinifile;
begin
  MyIniFile := TIniFile.Create(ExtractFilePath(Application.EXEName)+'material\'+combobox1.Text+'.mat');
  with MyIniFile do
  begin
      Edit1.text := Readstring('Main', 'Lambda', '');
  MyIniFile.Free;
  Button1.Enabled:=false;
end;
end;

procedure TForm14.Button1Click(Sender: TObject);
var MyIniFile:Tinifile;
begin
if combobox1.ItemIndex <>-1 then begin
try
  MyIniFile := TIniFile.Create(ExtractFilePath(Application.EXEName)+'material\'+combobox1.Text+'.mat');
  with MyIniFile do
  begin
  writestring('Main','Lambda',edit1.Text);
  end;
MyIniFile.Free;
Button1.Enabled:=false;
Form1.ComboBox1Change(Sender);
except
on econverterror do
showmessage('   !!!');
end;
end;
end;

procedure TForm14.Edit1Change(Sender: TObject);
begin
Button1.Enabled:=true;
end;

procedure TForm14.BitBtn1Click(Sender: TObject);
begin
Button1Click(Sender);
form1.ComboBox3.ItemIndex;
end;

procedure TForm14.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
if key=#46 then
key:=#44;
if (((key>#57) or (key<#48))) and (key<>#8) and (key<>#44) then
key:=#0;
end;

end.
