unit Unit8;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,inifiles;

type
  TForm8 = class(TForm)
    ListView1: TListView;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    GroupBox1: TGroupBox;
    Button5: TButton;
    Edit5: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    ListView2: TListView;
    Button6: TButton;
    Label5: TLabel;
    Edit6: TEdit;
    Label6: TLabel;
    Edit7: TEdit;
    procedure FormShow(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form8: TForm8;
  jk:integer;
implementation

uses Unit4, Unit1;

{$R *.dfm}

procedure TForm8.FormShow(Sender: TObject);
var MyIniFile:Tinifile;
    s:string;
    i:integer;
begin
jk:=form4.ComboBox2.ItemIndex;
ListView1.Clear ;
 MyIniFile := TIniFile.Create(ExtractFilePath(Application.EXEName)+'materials_f.mat');
i:=0;
repeat
ListView1.Items.Add.Caption:=MyIniFile.readstring(floattostr(i), 'Name', '');
i:=i+1;
s:=MyIniFile.ReadString(floattostr(i),'name','');
until s='';
MyIniFile.Free;
ListView2.Clear ;
 MyIniFile := TIniFile.Create(ExtractFilePath(Application.EXEName)+'materials.mat');
i:=0;
repeat
ListView2.Items.Add.Caption:=MyIniFile.readstring(floattostr(i), 'Name', '');
i:=i+1;
s:=MyIniFile.ReadString(floattostr(i),'name','');
until s='';
MyIniFile.Free;

end;

procedure TForm8.ListView1Click(Sender: TObject);
var MyIniFile:Tinifile;
    i:integer;
    s:string;
begin
try
MyIniFile := TIniFile.Create(ExtractFilePath(Application.EXEName)+'materials_f.mat');
i:=listview1.Selected.Index ;
s:=MyIniFile.Readstring(inttostr(i),'Name','none');
edit1.Text :=floattostr(MyIniFile.ReadFloat(inttostr(i),'Conductivity',0));
edit2.Text :=floattostr(MyIniFile.ReadFloat(inttostr(i),'Density',0));
edit6.Text :=floattostr(MyIniFile.ReadFloat(inttostr(i),'Specific Heat',0));
listview1.Hint:=s;
MyIniFile.Free;
except
on eaccessviolation do begin
end;end;
end;


procedure TForm8.ListView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
ListView1Click(Sender);
end;

procedure TForm8.Button1Click(Sender: TObject);
begin
edit1.ReadOnly:=false;
edit2.ReadOnly:=false;
edit6.ReadOnly:=false;
end;

procedure TForm8.Button2Click(Sender: TObject);
var MyIniFile:Tinifile;
    i:integer;
    s:string;
begin
try

MyIniFile := TIniFile.Create(ExtractFilePath(Application.EXEName)+'materials_f.mat');
i:=listview1.Selected.Index ;
s:=MyIniFile.Readstring(inttostr(i),'Name','none');
MyIniFile.writeFloat(inttostr(i),'Conductivity',strtofloat(edit1.text));
MyIniFile.writeFloat(inttostr(i),'Density',strtofloat(edit2.text));
MyIniFile.writeFloat(inttostr(i),'Specific Heat',strtofloat(edit6.text));
edit1.ReadOnly:=true;
edit2.ReadOnly:=true;
edit6.ReadOnly:=true;
MyIniFile.Free;
except
on econverterror do begin
showmessage('  !!!');
end;end;
end;

procedure TForm8.Button3Click(Sender: TObject);
var MyIniFile:Tinifile;
    i:integer;
    s:string;
begin
try
MyIniFile := TIniFile.Create(ExtractFilePath(Application.EXEName)+'materials.mat');
i:=form1.combobox1.Items.Count ;
MyIniFile.writestring(inttostr(i),'Name',listview1.Selected.Caption);
MyIniFile.writeFloat(inttostr(i),'Conductivity',strtofloat(edit1.text));
MyIniFile.writeFloat(inttostr(i),'Density',strtofloat(edit2.text));
MyIniFile.writeFloat(inttostr(i),'Specific Heat',strtofloat(edit6.text));
form4.Combobox2.Items.Addobject(listview1.Selected.Caption,TObject(vsList));
MyIniFile.Free;
listview2.Items.Add.Caption:=listview1.Selected.Caption;
except
on eaccessviolation do begin

end;end;
end;

procedure TForm8.Button4Click(Sender: TObject);
label a;
var MyIniFile,ini1:Tinifile;
    i,j,d:integer;
    k1,k2,k3:double;
    s:string;
begin
try
i:=listview1.Selected.Index ;
if fileexists(ExtractFilePath(Application.EXEName)+'materials_temp.mat') then
deletefile(ExtractFilePath(Application.EXEName)+'materials_temp.mat');

MyIniFile := TIniFile.Create(ExtractFilePath(Application.EXEName)+'materials_f.mat');
Ini1 := TIniFile.Create(ExtractFilePath(Application.EXEName)+'materials_temp.mat');
for  j:=0 to listview1.Items.Count-1 do begin
if j>=i then
d:=j-1 else
d:=j;
if j=i then
goto a;
k1:=MyIniFile.readFloat(inttostr(j),'Conductivity',0);
k2:=MyIniFile.readFloat(inttostr(j),'Density',0);
k3:=MyIniFile.readFloat(inttostr(j),'Specific Heat',0);
s:=MyIniFile.readstring(inttostr(j),'Name','none');

Ini1.writestring(inttostr(d),'Name',s);
Ini1.writeFloat(inttostr(d),'Conductivity',k1);
Ini1.writeFloat(inttostr(d),'Density',k2);
Ini1.writeFloat(inttostr(d),'Specific Heat',k3);

a:
end;
listview1.Selected.Delete ;
MyIniFile.Free;
Ini1.Free;
deletefile(ExtractFilePath(Application.EXEName)+'materials_f.mat');
copyfile(pchar(ExtractFilePath(Application.EXEName)+'materials_temp.mat'),pchar(ExtractFilePath(Application.EXEName)+'materials_f.mat'),true);
deletefile(ExtractFilePath(Application.EXEName)+'materials_temp.mat');
except
on eaccessviolation do begin
showmessage('   !!!');
MyIniFile.Free;
Ini1.Free;
end;end;



end;

procedure TForm8.Button5Click(Sender: TObject);
var ini1:Tinifile;
    d:integer;
begin
try
d:=listview1.Items.Count ;
Ini1 := TIniFile.Create(ExtractFilePath(Application.EXEName)+'materials_f.mat');
Ini1.writestring(inttostr(d),'Name',edit5.Text);
Ini1.writeFloat(inttostr(d),'Conductivity',strtofloat(edit4.Text));
Ini1.writeFloat(inttostr(d),'Density',strtofloat(edit3.Text));
Ini1.writeFloat(inttostr(d),'Specific Heat',strtofloat(edit7.Text));
Ini1.Free ;
listview1.Items.Add.Caption:=edit5.Text;
except
on econverterror do begin

end;
end;
end;

procedure TForm8.Button6Click(Sender: TObject);
label a;
var MyIniFile,ini1:Tinifile;
    i,j,d:integer;
    k1,k2,k3:double;
    s:string;
begin
try
i:=listview2.Selected.Index ;
if fileexists(ExtractFilePath(Application.EXEName)+'materials_temp.mat') then
deletefile(ExtractFilePath(Application.EXEName)+'materials_temp.mat');

MyIniFile := TIniFile.Create(ExtractFilePath(Application.EXEName)+'materials.mat');
Ini1 := TIniFile.Create(ExtractFilePath(Application.EXEName)+'materials_temp.mat');
for  j:=0 to listview2.Items.Count-1 do begin
if j>=i then
d:=j-1 else
d:=j;
if j=i then
goto a;
k1:=MyIniFile.readFloat(inttostr(j),'Conductivity',0);
k2:=MyIniFile.readFloat(inttostr(j),'Density',0);
k3:=MyIniFile.readFloat(inttostr(j),'Specific Heat',0);
s:=MyIniFile.readstring(inttostr(j),'Name','none');

Ini1.writestring(inttostr(d),'Name',s);
Ini1.writeFloat(inttostr(d),'Conductivity',k1);
Ini1.writeFloat(inttostr(d),'Density',k2);
Ini1.writeFloat(inttostr(d),'Specific Heat',k3);

a:
end;
listview2.Selected.Delete ;
MyIniFile.Free;
Ini1.Free;
deletefile(ExtractFilePath(Application.EXEName)+'materials.mat');
copyfile(pchar(ExtractFilePath(Application.EXEName)+'materials_temp.mat'),pchar(ExtractFilePath(Application.EXEName)+'materials.mat'),true);
deletefile(ExtractFilePath(Application.EXEName)+'materials_temp.mat');
except
on eaccessviolation do begin
showmessage('   !!!');
MyIniFile.Free;
Ini1.Free;
end;end;



end;

procedure TForm8.FormHide(Sender: TObject);
begin
form1.ComboBox1.Clear;
form1.ComboBox4.Clear;
form1.formcreate(sender);
//form4.ComboBox2.ItemIndex:=jk;
end;

end.

